diff --git a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/EditGeoService.java b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/EditGeoService.java
index 340c18011a..5b55b14d7f 100644
--- a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/EditGeoService.java
+++ b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/EditGeoService.java
@@ -29,9 +29,10 @@ import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.Point;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
-import eu.etaxonomy.cdm.model.occurrence.FieldObservation;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
+import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
+import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;
 import eu.etaxonomy.cdm.persistence.dao.common.IDefinedTermDao;
 import eu.etaxonomy.cdm.persistence.dao.description.IDescriptionDao;
 import eu.etaxonomy.cdm.persistence.dao.occurrence.IOccurrenceDao;
@@ -146,29 +147,29 @@ public class EditGeoService implements IEditGeoService {
      */
     @Override
     public String getOccurrenceServiceRequestParameterString(List<SpecimenOrObservationBase> specimensOrObersvations,
-            Map<Class<? extends SpecimenOrObservationBase>, Color> specimenOrObservationTypeColors,
+            Map<SpecimenOrObservationType, Color> specimenOrObservationTypeColors,
             Boolean doReturnImage, Integer width, Integer height, String bbox, String backLayer) {
 
-        List<Point> fieldObservationPoints = new ArrayList<Point>();
+        List<Point> fieldUnitPoints = new ArrayList<Point>();
         List<Point> derivedUnitPoints = new ArrayList<Point>();
 
         IndividualsAssociation individualsAssociation;
-        DerivedUnitBase derivedUnit;
+        DerivedUnit derivedUnit;
 
         for (SpecimenOrObservationBase specimenOrObservationBase : specimensOrObersvations) {
             SpecimenOrObservationBase<?> specimenOrObservation = occurrenceDao
                     .load(specimenOrObservationBase.getUuid());
 
-            if (specimenOrObservation instanceof FieldObservation) {
-                fieldObservationPoints.add(((FieldObservation) specimenOrObservation).getGatheringEvent()
+            if (specimenOrObservation instanceof FieldUnit) {
+                fieldUnitPoints.add(((FieldUnit) specimenOrObservation).getGatheringEvent()
                         .getExactLocation());
             }
-            if (specimenOrObservation instanceof DerivedUnitBase<?>) {
-                registerDerivedUnitLocations((DerivedUnitBase) specimenOrObservation, derivedUnitPoints);
+            if (specimenOrObservation instanceof DerivedUnit) {
+                registerDerivedUnitLocations((DerivedUnit) specimenOrObservation, derivedUnitPoints);
             }
         }
 
-        return EditGeoServiceUtilities.getOccurrenceServiceRequestParameterString(fieldObservationPoints,
+        return EditGeoServiceUtilities.getOccurrenceServiceRequestParameterString(fieldUnitPoints,
                 derivedUnitPoints, specimenOrObservationTypeColors, doReturnImage, width, height, bbox, backLayer);
 
     }
@@ -177,14 +178,14 @@ public class EditGeoService implements IEditGeoService {
      * @param derivedUnit
      * @param derivedUnitPoints
      */
-    private void registerDerivedUnitLocations(DerivedUnitBase<?> derivedUnit, List<Point> derivedUnitPoints) {
+    private void registerDerivedUnitLocations(DerivedUnit derivedUnit, List<Point> derivedUnitPoints) {
 
         Set<SpecimenOrObservationBase> originals = derivedUnit.getOriginals();
         if (originals != null) {
             for (SpecimenOrObservationBase original : originals) {
-                if (original instanceof FieldObservation) {
-                    if (((FieldObservation) original).getGatheringEvent() != null) {
-                        Point point = ((FieldObservation) original).getGatheringEvent().getExactLocation();
+                if (original instanceof FieldUnit) {
+                    if (((FieldUnit) original).getGatheringEvent() != null) {
+                        Point point = ((FieldUnit) original).getGatheringEvent().getExactLocation();
                         if (point != null) {
                             // FIXME: remove next statement after
                             // DerivedUnitFacade or ABCD import is fixed
@@ -195,7 +196,7 @@ public class EditGeoService implements IEditGeoService {
                         }
                     }
                 } else {
-                    registerDerivedUnitLocations((DerivedUnitBase) original, derivedUnitPoints);
+                    registerDerivedUnitLocations((DerivedUnit) original, derivedUnitPoints);
                 }
             }
         }
diff --git a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/EditGeoServiceUtilities.java b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/EditGeoServiceUtilities.java
index 21baf65355..e69be9c9a9 100644
--- a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/EditGeoServiceUtilities.java
+++ b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/EditGeoServiceUtilities.java
@@ -38,13 +38,7 @@ import eu.etaxonomy.cdm.model.description.PresenceTerm;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaLevel;
 import eu.etaxonomy.cdm.model.location.Point;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
-import eu.etaxonomy.cdm.model.occurrence.FieldObservation;
-import eu.etaxonomy.cdm.model.occurrence.LivingBeing;
-import eu.etaxonomy.cdm.model.occurrence.Observation;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
-import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
+import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;
 import eu.etaxonomy.cdm.persistence.dao.common.IDefinedTermDao;
 
 /**
@@ -55,7 +49,6 @@ import eu.etaxonomy.cdm.persistence.dao.common.IDefinedTermDao;
  *
  * @author a.mueller
  * @created 17.11.2008
- * @version 1.0
  */
 public class EditGeoServiceUtilities {
     private static final Logger logger = Logger.getLogger(EditGeoServiceUtilities.class);
@@ -73,16 +66,17 @@ public class EditGeoServiceUtilities {
         EditGeoServiceUtilities.termDao= termDao;
     }
 
-    private static HashMap<Class<? extends SpecimenOrObservationBase>, Color> defaultSpecimenOrObservationTypeColors = null;
+    private static HashMap<SpecimenOrObservationType, Color> defaultSpecimenOrObservationTypeColors = null;
 
-    private static HashMap<Class<? extends SpecimenOrObservationBase>, Color> getDefaultSpecimenOrObservationTypeColors() {
+    private static HashMap<SpecimenOrObservationType, Color> getDefaultSpecimenOrObservationTypeColors() {
         if(defaultSpecimenOrObservationTypeColors == null){
-            defaultSpecimenOrObservationTypeColors = new HashMap<Class<? extends SpecimenOrObservationBase>, Color>();
-            defaultSpecimenOrObservationTypeColors.put(FieldObservation.class, Color.ORANGE);
-            defaultSpecimenOrObservationTypeColors.put(DerivedUnit.class, Color.RED);
-            defaultSpecimenOrObservationTypeColors.put(LivingBeing.class, Color.GREEN);
-            defaultSpecimenOrObservationTypeColors.put(Observation.class, Color.ORANGE);
-            defaultSpecimenOrObservationTypeColors.put(Specimen.class, Color.GRAY);
+            defaultSpecimenOrObservationTypeColors = new HashMap<SpecimenOrObservationType, Color>();
+            defaultSpecimenOrObservationTypeColors.put(SpecimenOrObservationType.FieldUnit, Color.ORANGE);
+            defaultSpecimenOrObservationTypeColors.put(SpecimenOrObservationType.DerivedUnit, Color.RED);
+            defaultSpecimenOrObservationTypeColors.put(SpecimenOrObservationType.LivingSpecimen, Color.GREEN);
+            defaultSpecimenOrObservationTypeColors.put(SpecimenOrObservationType.Observation, Color.ORANGE);
+            defaultSpecimenOrObservationTypeColors.put(SpecimenOrObservationType.PreservedSpecimen, Color.GRAY);
+            defaultSpecimenOrObservationTypeColors.put(SpecimenOrObservationType.Media, Color.BLUE);
         }
         return defaultSpecimenOrObservationTypeColors;
     }
@@ -481,7 +475,7 @@ public class EditGeoServiceUtilities {
 		NamedArea area = distribution.getArea();
 		TermVocabulary<NamedArea> voc = area.getVocabulary();
 		String result = null;
-		if (voc !=  null && voc.getUuid().equals(TdwgArea.uuidTdwgAreaVocabulary) || voc.getUuid().equals(uuidCyprusDivisionsVocabulary) ){
+		if (voc !=  null && voc.getUuid().equals(NamedArea.uuidTdwgAreaVocabulary) || voc.getUuid().equals(uuidCyprusDivisionsVocabulary) ){
 			Representation representation = area.getRepresentation(Language.DEFAULT());
 			result = representation.getAbbreviatedLabel();
 			if (area.getLevel() != null && area.getLevel().equals(NamedAreaLevel.TDWG_LEVEL4())){
@@ -514,7 +508,7 @@ public class EditGeoServiceUtilities {
         String matchedLayerName = null;
         TermVocabulary<NamedArea> voc = area.getVocabulary();
         //TDWG areas
-        if (voc.getUuid().equals(TdwgArea.uuidTdwgAreaVocabulary)){
+        if (voc.getUuid().equals(NamedArea.uuidTdwgAreaVocabulary)){
             NamedAreaLevel level = area.getLevel();
             if (level != null) {
                 //TODO integrate into CDM
@@ -553,7 +547,7 @@ public class EditGeoServiceUtilities {
 	private static String getWMSLayerName(NamedArea area, IGeoServiceAreaMapping mapping){
 		TermVocabulary<NamedArea> voc = area.getVocabulary();
 		//TDWG areas
-		if (voc.getUuid().equals(TdwgArea.uuidTdwgAreaVocabulary)){
+		if (voc.getUuid().equals(NamedArea.uuidTdwgAreaVocabulary)){
 			NamedAreaLevel level = area.getLevel();
 			if (level != null) {
 				//TODO integrate into CDM
@@ -605,7 +599,7 @@ public class EditGeoServiceUtilities {
     }
 
     /**
-     * @param fieldObservationPoints
+     * @param fieldUnitPoints
      * @param derivedUnitPoints
      * @param specimenOrObservationTypeColors
      * @param doReturnImage TODO
@@ -625,10 +619,10 @@ public class EditGeoServiceUtilities {
      *  &os=1%3Ac%2FFFD700%2F10%2FAporrectodea caliginosa
      */
     public static String getOccurrenceServiceRequestParameterString(
-            List<Point> fieldObservationPoints,
-            List<Point> derivedUnitPoints,
-            Map<Class<? extends SpecimenOrObservationBase>, Color> specimenOrObservationTypeColors,
-            Boolean doReturnImage, Integer width, Integer height, String bbox, String backLayer) {
+            	List<Point> fieldUnitPoints,
+            	List<Point> derivedUnitPoints,
+            	Map<SpecimenOrObservationType, Color> specimenOrObservationTypeColors,
+            	Boolean doReturnImage, Integer width, Integer height, String bbox, String backLayer) {
 
             specimenOrObservationTypeColors = mergeMaps(getDefaultSpecimenOrObservationTypeColors(), specimenOrObservationTypeColors);
 
@@ -645,8 +639,8 @@ public class EditGeoServiceUtilities {
 
             Map<String, String> styleAndData = new HashMap<String, String>();
 
-            addToStyleAndData(fieldObservationPoints, FieldObservation.class, specimenOrObservationTypeColors, styleAndData);
-            addToStyleAndData(derivedUnitPoints, DerivedUnit.class, specimenOrObservationTypeColors, styleAndData);
+            addToStyleAndData(fieldUnitPoints, SpecimenOrObservationType.FieldUnit, specimenOrObservationTypeColors, styleAndData);
+            addToStyleAndData(derivedUnitPoints, SpecimenOrObservationType.DerivedUnit, specimenOrObservationTypeColors, styleAndData);
 
             parameters.put("os", StringUtils.join(styleAndData.keySet().iterator(), "||"));
             parameters.put("od", StringUtils.join(styleAndData.values().iterator(), "||"));
@@ -676,8 +670,8 @@ public class EditGeoServiceUtilities {
 
     private static void addToStyleAndData(
             List<Point> points,
-            Class<? extends SpecimenOrObservationBase> specimenOrObservationType,
-            Map<Class<? extends SpecimenOrObservationBase>, Color> specimenOrObservationTypeColors, Map<String, String> styleAndData) {
+            SpecimenOrObservationType specimenOrObservationType,
+            Map<SpecimenOrObservationType, Color> specimenOrObservationTypeColors, Map<String, String> styleAndData) {
 
         //TODO add markerShape and size and Label to specimenOrObservationTypeColors -> Map<Class<SpecimenOrObservationBase<?>>, MapStyle>
 
diff --git a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/IEditGeoService.java b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/IEditGeoService.java
index a141c9f24d..0dad45897a 100644
--- a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/IEditGeoService.java
+++ b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/geo/IEditGeoService.java
@@ -22,6 +22,7 @@ import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
+import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;
 
 /**
  * @author a.kohlbecker
@@ -106,7 +107,7 @@ public interface IEditGeoService {
 
 	public String getOccurrenceServiceRequestParameterString(
 			List<SpecimenOrObservationBase> specimensOrObersvations,
-			Map<Class<? extends SpecimenOrObservationBase>,Color> specimenOrObservationTypeColors,
+			Map<SpecimenOrObservationType,Color> specimenOrObservationTypeColors,
 			Boolean doReturnImage,
 			Integer width,
 			Integer height,
diff --git a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/ipni/IpniService.java b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/ipni/IpniService.java
index a0e14454ad..89e7c713ce 100644
--- a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/ipni/IpniService.java
+++ b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/ipni/IpniService.java
@@ -31,7 +31,6 @@ import org.springframework.stereotype.Component;
 
 import eu.etaxonomy.cdm.api.application.ICdmApplicationConfiguration;
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
-import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade.DerivedUnitType;
 import eu.etaxonomy.cdm.common.CdmUtils;
 import eu.etaxonomy.cdm.common.UriUtils;
 import eu.etaxonomy.cdm.model.agent.Person;
@@ -42,15 +41,18 @@ import eu.etaxonomy.cdm.model.common.Extension;
 import eu.etaxonomy.cdm.model.common.ExtensionType;
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.common.TimePeriod;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.NomenclaturalCode;
 import eu.etaxonomy.cdm.model.name.NomenclaturalStatus;
 import eu.etaxonomy.cdm.model.name.NomenclaturalStatusType;
 import eu.etaxonomy.cdm.model.name.Rank;
+import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
 import eu.etaxonomy.cdm.strategy.exceptions.UnknownCdmTypeException;
+import eu.etaxonomy.cdm.strategy.parser.TimePeriodParser;
 
 
 /**
@@ -371,13 +373,13 @@ public class IpniService  implements IIpniService{
 
 		
 		//dates
-		TimePeriod date = TimePeriod.parseString(valueMap.get(DATE));
+		TimePeriod date = TimePeriodParser.parseString(valueMap.get(DATE));
 		ref.setDatePublished(date);
 
 
 		//source
 		Reference citation = getIpniCitation(appConfig);
-		ref.addSource(valueMap.get(ID), "Publication", citation, valueMap.get(VERSION));
+		ref.addSource(OriginalSourceType.Lineage, valueMap.get(ID), "Publication", citation, valueMap.get(VERSION));
 
 		
 		
@@ -439,7 +441,7 @@ public class IpniService  implements IIpniService{
 		//rank
 		try {
 			String rankStr = nomalizeRank(valueMap.get(RANK));
-			name.setRank(Rank.getRankByNameOrAbbreviation(rankStr, NomenclaturalCode.ICBN, true));
+			name.setRank(Rank.getRankByNameOrIdInVoc(rankStr, NomenclaturalCode.ICNAFP, true));
 		} catch (UnknownCdmTypeException e) {
 			logger.warn("Rank was unknown");
 		}
@@ -451,7 +453,7 @@ public class IpniService  implements IIpniService{
 		//publication
 		Reference ref = ReferenceFactory.newGeneric();
 		ref.setTitleCache(valueMap.get(PUBLICATION));
-		TimePeriod datePublished = TimePeriod.parseString(valueMap.get(PUBLICATION_YEAR_FULL));
+		TimePeriod datePublished = TimePeriodParser.parseString(valueMap.get(PUBLICATION_YEAR_FULL));
 		name.setNomenclaturalReference(ref);
 		
 		//name status
@@ -483,12 +485,12 @@ public class IpniService  implements IIpniService{
 		name.addReplacedSynonym(replacedSynoynm, null, null, null);
 
 		//type information
-		DerivedUnitFacade specimen = DerivedUnitFacade.NewInstance(DerivedUnitType.Specimen);
+		DerivedUnitFacade specimen = DerivedUnitFacade.NewInstance(SpecimenOrObservationType.PreservedSpecimen);
 		
 		
 		//gathering period
 		String collectionDateAsText = valueMap.get(COLLECTION_DATE_AS_TEXT);
-		TimePeriod gatheringPeriod = TimePeriod.parseString(collectionDateAsText);
+		TimePeriod gatheringPeriod = TimePeriodParser.parseString(collectionDateAsText);
 		
 		try {
 			gatheringPeriod.setStartDay(getIntegerDateValueOrNull(valueMap, COLLECTION_DAY1));
@@ -549,7 +551,7 @@ public class IpniService  implements IIpniService{
 		
 		//source
 		Reference citation = getIpniCitation(appConfig);
-		name.addSource(valueMap.get(ID), "Name", citation, valueMap.get(VERSION));
+		name.addSource(OriginalSourceType.Lineage, valueMap.get(ID), "Name", citation, valueMap.get(VERSION));
 		
 		
 //		//TODO
@@ -671,13 +673,13 @@ public class IpniService  implements IIpniService{
 		person.setFirstname(valueMap.get(DEFAULT_AUTHOR_FORENAME));
 		person.setLastname(valueMap.get(DEFAULT_AUTHOR_SURNAME));
 		
-		Reference citation = getIpniCitation(appConfig);
+		Reference<?> citation = getIpniCitation(appConfig);
 		
 		//id, version
-		person.addSource(valueMap.get(ID), "Author", citation, valueMap.get(VERSION));
+		person.addSource(OriginalSourceType.Lineage, valueMap.get(ID), "Author", citation, valueMap.get(VERSION));
 		
 		//dates
-		TimePeriod lifespan = TimePeriod.parseString(valueMap.get(DATES));
+		TimePeriod lifespan = TimePeriodParser.parseString(valueMap.get(DATES));
 		person.setLifespan(lifespan);
 		
 		//alternative_names
@@ -699,7 +701,7 @@ public class IpniService  implements IIpniService{
 
 	
 	private Reference getIpniCitation(ICdmApplicationConfiguration appConfig) {
-		Reference ipniReference;
+		Reference<?> ipniReference;
 		if (appConfig != null){
 			ipniReference = appConfig.getReferenceService().find(uuidIpni);
 			if (ipniReference == null){
@@ -717,7 +719,7 @@ public class IpniService  implements IIpniService{
 	 * @return
 	 */
 	private Reference getNewIpniReference() {
-		Reference ipniReference;
+		Reference<?> ipniReference;
 		ipniReference = ReferenceFactory.newDatabase();
 		ipniReference.setTitleCache("The International Plant Names Index (IPNI)");
 		return ipniReference;
diff --git a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/openurl/MobotOpenUrlServiceWrapper.java b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/openurl/MobotOpenUrlServiceWrapper.java
index d27a06936c..21a45861f6 100644
--- a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/openurl/MobotOpenUrlServiceWrapper.java
+++ b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/openurl/MobotOpenUrlServiceWrapper.java
@@ -18,12 +18,9 @@ import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
-import org.apache.http.HttpException;
 import org.apache.http.NameValuePair;
 import org.apache.http.message.BasicNameValuePair;
-import org.xml.sax.InputSource;
 
-import eu.etaxonomy.cdm.common.StreamUtils;
 import eu.etaxonomy.cdm.ext.common.SchemaAdapterBase;
 import eu.etaxonomy.cdm.ext.common.ServiceWrapperBase;
 import eu.etaxonomy.cdm.model.reference.Reference;
@@ -77,51 +74,51 @@ public class MobotOpenUrlServiceWrapper extends ServiceWrapperBase<OpenUrlRefere
             logger.error("No SchemaAdapter found for " + query.schemaShortName);
         }
 
-        addNewPairNN(pairs, "format", "xml");
-        addNewPairNN(pairs, "url_ver", urlVersion);
+        addNameValuePairTo(pairs, "format", "xml");
+        addNameValuePairTo(pairs, "url_ver", urlVersion);
         /* info:ofi/fmt:kev:mtx:book or info:ofi/fmt:kev:mtx:journal */
-        addNewPairNN(pairs, "rft_val_fmt", "info:ofi/fmt:kev:mtx:" + query.refType);
+        addNameValuePairTo(pairs, "rft_val_fmt", "info:ofi/fmt:kev:mtx:" + query.refType);
         /* Book title */
-        addNewPairNN(pairs, "rft.btitle", query.bookTitle);
+        addNameValuePairTo(pairs, "rft.btitle", query.bookTitle);
         /* Journal title */
-        addNewPairNN(pairs, "rft.jtitle", query.journalTitle);
+        addNameValuePairTo(pairs, "rft.jtitle", query.journalTitle);
         /* Author name ("last, first" or "corporation") */
-        addNewPairNN(pairs, "rft.au", query.authorName);
+        addNameValuePairTo(pairs, "rft.au", query.authorName);
         /* Author last name */
-        addNewPairNN(pairs, "rft.aulast", query.authorLastName);
+        addNameValuePairTo(pairs, "rft.aulast", query.authorLastName);
         /* Author first name */
-        addNewPairNN(pairs, "rft.aufirst", query.authorFirstName);
+        addNameValuePairTo(pairs, "rft.aufirst", query.authorFirstName);
         /* Author name (corporation) */
-        addNewPairNN(pairs, "rft.aucorp", query.authorNameCorporation);
+        addNameValuePairTo(pairs, "rft.aucorp", query.authorNameCorporation);
         /* Publication details */
-        addNewPairNN(pairs, "rft.publisher", query.publicationDetails);
+        addNameValuePairTo(pairs, "rft.publisher", query.publicationDetails);
         /* Publisher name */
-        addNewPairNN(pairs, "rft.pub", query.publisherName);
+        addNameValuePairTo(pairs, "rft.pub", query.publisherName);
         /* Publication place */
-        addNewPairNN(pairs, "rft.place", query.publicationPlace);
+        addNameValuePairTo(pairs, "rft.place", query.publicationPlace);
         /* Publication date (YYYY or YYYY-MM or YYYY-MM-DD) */
-        addNewPairNN(pairs, "rft.date", query.publicationDate);
+        addNameValuePairTo(pairs, "rft.date", query.publicationDate);
         /* ISSN */
-        addNewPairNN(pairs, "rft.issn", query.ISSN);
+        addNameValuePairTo(pairs, "rft.issn", query.ISSN);
         /* ISBN */
-        addNewPairNN(pairs, "rft.isbn", query.ISBN);
+        addNameValuePairTo(pairs, "rft.isbn", query.ISBN);
         /* CODEN */
-        addNewPairNN(pairs, "rft.coden", query.CODEN);
+        addNameValuePairTo(pairs, "rft.coden", query.CODEN);
         /* Abbreviation = abbreviated Title */
-        addNewPairNN(pairs, "rft.stitle", query.abbreviation);
+        addNameValuePairTo(pairs, "rft.stitle", query.abbreviation);
         /* Volume */
-        addNewPairNN(pairs, "rft.volume", query.volume);
+        addNameValuePairTo(pairs, "rft.volume", query.volume);
         /* Issue */
-        addNewPairNN(pairs, "rft.issue", query.issue);
+        addNameValuePairTo(pairs, "rft.issue", query.issue);
         /* Start page */
         if(query.startPage != null){
             Integer page = parsePageNumber(query.startPage);
-            addNewPairNN(pairs, "rft.spage", page.toString());
+            addNameValuePairTo(pairs, "rft.spage", page.toString());
         }
         /* BHL title ID (where XXXX is the ID value)*/
-        addNewPairNN(pairs, "rft_id" , query.bhlTitleURI);
+        addNameValuePairTo(pairs, "rft_id" , query.bhlTitleURI);
         /* BHL page ID (where XXXX is the ID value)*/
-        addNewPairNN(pairs, "rft_id", query.bhlPageURI);
+        addNameValuePairTo(pairs, "rft_id", query.bhlPageURI);
 
         /* OCLC number (where XXXX is the ID value)*/
         if(query.oclcNumber != null){
@@ -158,9 +155,6 @@ public class MobotOpenUrlServiceWrapper extends ServiceWrapperBase<OpenUrlRefere
         } catch (URISyntaxException e) {
             // thrown by createUri
             logger.error(e);
-        } catch (HttpException e) {
-            // thrown by executeHttpGet
-            logger.error(e);
         }
 
         return null;
diff --git a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/scratchpads/ScratchpadsService.java b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/scratchpads/ScratchpadsService.java
new file mode 100644
index 0000000000..bc8993cc8c
--- /dev/null
+++ b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/scratchpads/ScratchpadsService.java
@@ -0,0 +1,227 @@
+// $Id$
+/**
+ * Copyright (C) 2009 EDIT
+ * European Distributed Institute of Taxonomy 
+ * http://www.e-taxonomy.eu
+ * 
+ * The contents of this file are subject to the Mozilla Public License Version 1.1
+ * See LICENSE.TXT at the top of this package for the full license terms.
+ */
+package eu.etaxonomy.cdm.ext.scratchpads;
+
+import java.io.BufferedReader;
+import java.io.FileNotFoundException;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.net.URL;
+import java.util.Iterator;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipInputStream;
+
+import org.apache.http.HttpException;
+import org.apache.http.HttpResponse;
+import org.apache.log4j.Logger;
+import org.codehaus.jackson.JsonNode;
+import org.codehaus.jackson.map.ObjectMapper;
+
+import eu.etaxonomy.cdm.common.UriUtils;
+
+
+/**
+ * @author l.morris
+ * @date Jul 2, 2013
+ *
+ */
+public class ScratchpadsService {
+
+	private static final Logger logger = Logger.getLogger(ScratchpadsService.class);
+
+	public static final String SCRATCHPADS_JSON_ENDPOINT = "http://scratchpads.eu/explore/sites-list/json";
+
+	private static final char[] ILLEGAL_CHARACTERS = { '/', '\n', '\r', '\t', '\0', '\f', '`', '?', '*', '\\', '<', '>', '|', '\"', ':', '.' };
+
+	private static final String dir = "C:\\Users\\l.morris\\Downloads\\dwca_scratchpads\\";
+	
+	public void harvest(){
+
+		InputStream inputStream = null;
+		
+		try {
+			URL url = new URL(SCRATCHPADS_JSON_ENDPOINT);
+			boolean isAvailable = UriUtils.isServiceAvailable(url.toURI());
+
+			if (isAvailable) {
+				inputStream = UriUtils.getInputStream(url.toURI());
+			}
+
+			BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream, "iso-8859-1"), 8);
+			StringBuilder sb = new StringBuilder();
+			String line = null;
+			while ((line = reader.readLine()) != null) {
+				sb.append(line + "\n");
+				logger.debug(line);
+				
+			}
+
+			ObjectMapper m = new ObjectMapper();			
+			
+			JsonNode rootNode = m.readTree(sb.toString());
+			logger.debug(rootNode.toString());
+			logger.debug(rootNode.isArray());
+			
+			int num = 0;
+			if (rootNode.isArray()) {
+				Iterator<JsonNode> arrayElements = rootNode.getElements();
+				while (arrayElements.hasNext()) {
+					JsonNode element = arrayElements.next();
+					JsonNode website = element.path("field_website");
+					//logger.debug(website.getValueAsText());
+					String fieldWebsite = website.getValueAsText();
+					
+					if (fieldWebsite.startsWith("http")) {
+
+						url = new URL(fieldWebsite + "/dwca.zip");
+						URI uri = url.toURI();
+						isAvailable = UriUtils.isServiceAvailable(uri);
+						logger.debug("Is " + fieldWebsite + " available :" + isAvailable);
+
+						String websiteName = "";
+						//websiteName = (fieldWebsite.toString().split("//")[1]).split(".*")[0];
+						websiteName = websiteName + fieldWebsite.split("//")[1];
+						//if (websiteName.contains(".")){
+							//websiteName = websiteName.substring(0, websiteName.indexOf("."));
+						websiteName = websiteName.replaceAll("\\.", "_");
+							//websiteName = websiteName.substring(0, websiteName.indexOf("."));
+
+						//} 
+
+						//logger.debug("the website name " + websiteName);
+
+						for (int j = 0; j < ILLEGAL_CHARACTERS.length; j++) {
+
+							char ch = '_';
+							websiteName.replace(ILLEGAL_CHARACTERS[j], ch);
+						}
+
+						websiteName = websiteName.substring(0, websiteName.length());
+
+						if (isAvailable) {
+
+							HttpResponse response = UriUtils.getResponse(uri, null);
+							if (UriUtils.isOk(response)) {
+
+
+								logger.debug("There is a dwca " + websiteName);
+
+								try {
+									inputStream = UriUtils.getInputStream(url.toURI());
+
+									num++;
+
+									if (inputStream != null) {
+
+										copyDwcaZip(inputStream, websiteName);
+										//createDwcaZip(inputStream);
+									}
+									
+								} catch (HttpException e) {
+									// TODO Auto-generated catch block
+									logger.error("Failed to get dwca for " + websiteName + " as there was an error " + e);
+								} 
+
+							}
+
+						}
+					}
+				}
+			}
+
+			inputStream.close();
+
+
+		} catch (URISyntaxException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} catch (IOException ie) {
+			ie.printStackTrace();
+		} catch (HttpException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} 
+	}
+	
+	/**
+	 * FIXME
+	 * This is a hack as dwca.zip files from Scratchpads sites have an extra directory when unzipped. i.e. all the text
+	 * and meta.xml are in the sub-directory dwca, but the should be directly in the top-level unzipped directory
+	 */
+	private void createDwcaZip (InputStream inputStream, String websiteName) {
+		
+		 ZipInputStream zis = new ZipInputStream(inputStream);
+	    
+	         byte[] buffer = new byte[4096];
+	         ZipEntry ze;
+	         try {
+				while ((ze = zis.getNextEntry()) != null)
+				 {
+				    System.out.println("Extracting: " + ze);
+				    
+				    FileOutputStream fos = new FileOutputStream(ze.getName());
+				    {
+				       int numBytes;
+				       while ((numBytes = zis.read(buffer, 0, buffer.length)) != -1)
+				          fos.write(buffer, 0, numBytes);
+				    }
+				    zis.closeEntry();
+				 }
+			} catch (FileNotFoundException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			} catch (IOException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}		
+		
+	}
+	
+	/*
+	 * Use this method instead of createDwcaZip, once the dwca.zip structure is fixed in Scratchpads
+	 */
+	private void copyDwcaZip (InputStream inputStream, String websiteName) {
+		
+		FileOutputStream outputStream;
+		try {
+			outputStream = new FileOutputStream("dwca_" + websiteName + ".zip");//dir + 
+
+			byte[] b = new byte[1024];
+			int count;
+			while ((count = inputStream.read(b)) >= 0) {
+				outputStream.write(b, 0, count);
+			}
+			outputStream.flush(); 
+			outputStream.close(); 
+			inputStream.close();   
+		} catch (FileNotFoundException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} catch (IOException ie) {
+			ie.printStackTrace();
+		} 
+	}
+
+	/**
+	 * @param args
+	 */
+	public static void main(String[] args) {
+
+		ScratchpadsService spService = new ScratchpadsService();
+		spService.harvest();
+		// TODO Auto-generated method stub
+
+	}
+
+}
